HaskellForMaths-0.4.8: Combinatorics, group theory, commutative algebra, non-commutative algebra

Safe Haskell | None
Language | Haskell98

Math.Algebras.NonCommutative

Description

A module defining the algebra of non-commutative polynomials over a field k

# Documentation

data NonComMonomial v Source #

Constructors

NCM Int [v] |

Instances

Monomial NonComMonomial Source # |
Methods var :: v -> Vect Q (NonComMonomial v) Source # powers :: Eq v => NonComMonomial v -> [(v, Int)] Source #
(Eq k, Num k, Ord v) => Algebra k (NonComMonomial v) Source # |
Methods unit :: k -> Vect k (NonComMonomial v) Source # mult :: Vect k (Tensor (NonComMonomial v) (NonComMonomial v)) -> Vect k (NonComMonomial v) Source #
Eq v => Eq (NonComMonomial v) Source # |
Methods (==) :: NonComMonomial v -> NonComMonomial v -> Bool # (/=) :: NonComMonomial v -> NonComMonomial v -> Bool #
Ord v => Ord (NonComMonomial v) Source # |

Methods

compare :: NonComMonomial v -> NonComMonomial v -> Ordering #

(<) :: NonComMonomial v -> NonComMonomial v -> Bool #

(<=) :: NonComMonomial v -> NonComMonomial v -> Bool #

(>) :: NonComMonomial v -> NonComMonomial v -> Bool #

(>=) :: NonComMonomial v -> NonComMonomial v -> Bool #

max :: NonComMonomial v -> NonComMonomial v -> NonComMonomial v #

min :: NonComMonomial v -> NonComMonomial v -> NonComMonomial v #

(Eq v, Show v) => Show (NonComMonomial v) Source # |
Methods showsPrec :: Int -> NonComMonomial v -> ShowS # show :: NonComMonomial v -> String # showList :: [NonComMonomial v] -> ShowS #
Mon (NonComMonomial v) Source # |
Methods munit :: NonComMonomial v Source # mmult :: NonComMonomial v -> NonComMonomial v -> NonComMonomial v Source #
Eq v => DivisionBasis (NonComMonomial v) Source # |
Methods divM :: NonComMonomial v -> NonComMonomial v -> Maybe (NonComMonomial v, NonComMonomial v) Source #

class Monomial m where Source #

Minimal complete definition

var, powers

Methods

var :: v -> Vect Q (m v) Source #

powers :: Eq v => m v -> [(v, Int)] Source #

Instances

Monomial NonComMonomial Source # |
Methods var :: v -> Vect Q (NonComMonomial v) Source # powers :: Eq v => NonComMonomial v -> [(v, Int)] Source #
Monomial SL2q Source # |
Methods var :: v -> Vect Q (SL2q v) Source # powers :: Eq v => SL2q v -> [(v, Int)] Source #
Monomial M2q Source # |
Methods var :: v -> Vect Q (M2q v) Source # powers :: Eq v => M2q v -> [(v, Int)] Source #
Monomial Aq02 Source # |
Methods var :: v -> Vect Q (Aq02 v) Source # powers :: Eq v => Aq02 v -> [(v, Int)] Source #
Monomial Aq20 Source # |
Methods var :: v -> Vect Q (Aq20 v) Source # powers :: Eq v => Aq20 v -> [(v, Int)] Source #

bind :: (Eq t, Eq k, Monomial m, Algebra k b, Show b, Ord b, Num k) => Vect k (m t) -> (t -> Vect k b) -> Vect k b Source #

type NCPoly v = Vect Q (NonComMonomial v) Source #

class DivisionBasis m where Source #

Minimal complete definition

divM

Methods

divM :: m -> m -> Maybe (m, m) Source #

Instances

Eq v => DivisionBasis (NonComMonomial v) Source # |
Methods divM :: NonComMonomial v -> NonComMonomial v -> Maybe (NonComMonomial v, NonComMonomial v) Source #

ncm :: [v] -> NonComMonomial v Source #

lm :: Vect t t1 -> t1 Source #

lc :: Vect t1 t -> t1 Source #

lt :: Vect k b -> Vect k b Source #

quotRemNP :: (Fractional t, DivisionBasis m, Algebra t m, Show m, Ord m, Eq t) => Vect t m -> [Vect t m] -> ([(Vect t m, Vect t m)], Vect t m) Source #

remNP :: (Fractional t, DivisionBasis m, Algebra t m, Show m, Ord m, Eq t) => Vect t m -> [Vect t m] -> Vect t m Source #

(%%) :: (Eq t, Ord m, Show m, Algebra t m, DivisionBasis m, Fractional t) => Vect t m -> [Vect t m] -> Vect t m infixl 7 Source #